import { Event } from '@we-scrum/core';
import { Context } from './context';
export declare abstract class Aggregate {
    protected id: string;
    private handlers;
    constructor();
    on<E extends Event>(event: new () => E, handler: EventHandler<E>): void;
    apply<E extends Event>(event: E): void;
    protected publish<E extends Event>(event: E, context: Context): void;
}
export interface EventHandler<T extends Event> {
    (event: T): void;
}
