"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Aggregate = void 0;
var core_1 = require("@we-scrum/core");
var Aggregate = /** @class */ (function () {
    function Aggregate() {
        this.id = null;
        this.handlers = new Map();
        this.id = core_1.guid();
    }
    Aggregate.prototype.on = function (event, handler) {
        this.handlers.set(new event().type, handler);
    };
    Aggregate.prototype.apply = function (event) {
        var handler = this.handlers.get(event.type);
        if (!handler) {
            throw new Error("No handler for " + event.type + " in " + this.constructor.name);
        }
        handler(event);
    };
    Aggregate.prototype.publish = function (event, context) {
        event.aggregateId = this.id;
        event.publishedBy = context.user.uid;
        this.apply(event);
        context.addEvent(event);
    };
    return Aggregate;
}());
exports.Aggregate = Aggregate;
//# sourceMappingURL=aggregate.js.map