"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Context = void 0;
var core_1 = require("@we-scrum/core");
var Context = /** @class */ (function () {
    function Context(db, factory, user, handledEventSnapShot) {
        this.db = db;
        this.factory = factory;
        this.user = user;
        this.handledEventSnapShot = handledEventSnapShot;
        this.factoryMap = new Map();
        this.events = [];
        this.operations = [];
    }
    Context.prototype.deleteHandledEvent = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.handledEventSnapShot.ref.delete()];
            });
        });
    };
    Context.prototype.saveDocumentsAndPublishEvents = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, operation, _b, _c, event;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        core_1.Logger.info("Saving " + this.getOperations().length + " operations");
                        _i = 0, _a = this.getOperations();
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 9];
                        operation = _a[_i];
                        if (!(operation.action === Context.Action.Create)) return [3 /*break*/, 3];
                        core_1.Logger.info("Create document " + operation.document._path);
                        return [4 /*yield*/, this.db.doc(operation.document._path).set(core_1.serialize(operation.document))];
                    case 2:
                        _d.sent();
                        return [3 /*break*/, 8];
                    case 3:
                        if (!(operation.action === Context.Action.Update)) return [3 /*break*/, 5];
                        core_1.Logger.info("Update document " + operation.document._path);
                        return [4 /*yield*/, this.db.doc(operation.document._path).set(core_1.serialize(operation.document))];
                    case 4:
                        _d.sent();
                        return [3 /*break*/, 8];
                    case 5:
                        if (!(operation.action === Context.Action.Delete)) return [3 /*break*/, 7];
                        core_1.Logger.info("Delete document " + operation.document._path);
                        return [4 /*yield*/, this.db.doc(operation.document._path).delete()];
                    case 6:
                        _d.sent();
                        return [3 /*break*/, 8];
                    case 7: throw new Error("Transactional Repository: Not supported action " + operation.action);
                    case 8:
                        _i++;
                        return [3 /*break*/, 1];
                    case 9:
                        core_1.Logger.info("Publishing " + this.getEvents().length + " events");
                        _b = 0, _c = this.getEvents();
                        _d.label = 10;
                    case 10:
                        if (!(_b < _c.length)) return [3 /*break*/, 13];
                        event = _c[_b];
                        return [4 /*yield*/, this.db.collection('events').add(core_1.serialize(event))];
                    case 11:
                        _d.sent();
                        _d.label = 12;
                    case 12:
                        _b++;
                        return [3 /*break*/, 10];
                    case 13: return [2 /*return*/];
                }
            });
        });
    };
    Context.prototype.get = function (type) {
        if (!this.factoryMap.has(type)) {
            this.factoryMap.set(type, this.factory(type, this));
        }
        return this.factoryMap.get(type);
    };
    Context.prototype.addEvent = function (event) {
        this.events.push(event);
    };
    Context.prototype.getEvents = function () {
        return this.events;
    };
    Context.prototype.createDocument = function (document) {
        this.operations.push({ document: document, action: Context.Action.Create });
    };
    Context.prototype.updateDocument = function (document) {
        this.operations.push({ document: document, action: Context.Action.Update });
    };
    Context.prototype.deleteDocument = function (document) {
        this.operations.push({ document: document, action: Context.Action.Delete });
    };
    Context.prototype.getOperations = function () {
        return this.operations;
    };
    return Context;
}());
exports.Context = Context;
(function (Context) {
    var Action;
    (function (Action) {
        Action[Action["Create"] = 'Create'] = "Create";
        Action[Action["Update"] = 'Update'] = "Update";
        Action[Action["Delete"] = 'Delete'] = "Delete";
    })(Action = Context.Action || (Context.Action = {}));
})(Context = exports.Context || (exports.Context = {}));
exports.Context = Context;
//# sourceMappingURL=context.js.map