import { Command, Event } from '@we-scrum/core';
import { firestore } from 'firebase-admin';
import { EventContext, firestore as functionsFirestore } from 'firebase-functions';
import { Bus } from './bus';
import { Context } from './context';
import { Server } from './server';
export declare class HandlerHelper {
    static getRequestCommandHandler<C extends Command>(bus: Bus, type: new () => C): RequestHandler;
    static getRequestQueryHandler<R, P>(handler: (params: P, context: Context) => Promise<R>, query: new () => P): RequestHandler;
    static getFunctionEventHandler<E extends Event>(bus: Bus, db: firestore.Firestore, factory: Context.Factory): FunctionHandler;
    static wait(miliseconds: number): Promise<void>;
    private static publishEventsOnInternalBus;
    private static getElapesedTime;
}
export interface RequestHandler {
    (request: Server.Request, response: Server.Response): Promise<void>;
}
export interface FunctionHandler {
    (snapshot: functionsFirestore.DocumentSnapshot, eventContext: EventContext): Promise<void>;
}
