"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandlerHelper = void 0;
var core_1 = require("@we-scrum/core");
var context_1 = require("./context");
var execution_mode_enum_1 = require("./execution-mode-enum");
var server_1 = require("./server");
var HandlerHelper = /** @class */ (function () {
    function HandlerHelper() {
    }
    HandlerHelper.getRequestCommandHandler = function (bus, type) {
        var _this = this;
        return function (request, response) { return __awaiter(_this, void 0, void 0, function () {
            var command, commandName, startDate, result, error_1, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (request.body.__type !== type.name) {
                            throw new core_1.BadRequestError(type.name + " expected!");
                        }
                        try {
                            command = core_1.deserialize(request.body);
                            commandName = command.type;
                        }
                        catch (error) {
                            throw new core_1.BadRequestError("Impossible to deserialize " + JSON.stringify(request.body) + ", error " + JSON.stringify(error));
                        }
                        startDate = new Date();
                        core_1.Logger.info('-'.repeat(30) + "Command API" + '-'.repeat(30));
                        core_1.Logger.info("Start handling command " + commandName);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        return [4 /*yield*/, bus.send(command, request.context)];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, this.publishEventsOnInternalBus(bus, request.context)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, request.context.saveDocumentsAndPublishEvents()];
                    case 4:
                        _a.sent();
                        response.status(server_1.Server.statusCodes.OK).send({ status: 'OK', result: result });
                        return [3 /*break*/, 6];
                    case 5:
                        error_1 = _a.sent();
                        if (!(error_1 instanceof Error)) {
                            error_1 = new Error(error_1);
                        }
                        status = server_1.Server.statusCodes.INTERNAL_SERVER_ERROR;
                        if (error_1.name === 'UnauthorizedError') {
                            status = server_1.Server.statusCodes.UNAUTHORIZED;
                        }
                        else if (error_1.name === 'BadRequestError') {
                            status = server_1.Server.statusCodes.BAD_REQUEST;
                        }
                        else if (error_1.name === 'ForbiddenError') {
                            status = server_1.Server.statusCodes.FORBIDDEN;
                        }
                        else if (error_1.name === 'NotImplemented') {
                            status = server_1.Server.statusCodes.NOT_IMPLEMENTED;
                        }
                        else if (error_1.name === 'NotFoundError') {
                            status = server_1.Server.statusCodes.NOT_FOUND;
                        }
                        console.error(error_1);
                        response.status(status).send({
                            message: error_1.message
                        });
                        return [3 /*break*/, 6];
                    case 6:
                        core_1.Logger.infoWithElapesedTime(commandName + " handled", startDate);
                        core_1.Logger.info('-'.repeat(30) + "Command API" + '-'.repeat(30));
                        return [2 /*return*/];
                }
            });
        }); };
    };
    HandlerHelper.getRequestQueryHandler = function (handler, query) {
        var _this = this;
        return function (request, response) { return __awaiter(_this, void 0, void 0, function () {
            var params, startDate, result, error_2, status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = core_1.deserialize(Object.assign({}, request.params, request.query), query);
                        startDate = new Date();
                        core_1.Logger.info('-'.repeat(30) + "Query API" + '-'.repeat(30));
                        core_1.Logger.info("Start handling query");
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, handler(params, request.context)];
                    case 2:
                        result = _a.sent();
                        return [4 /*yield*/, request.context.saveDocumentsAndPublishEvents()];
                    case 3:
                        _a.sent();
                        response.status(server_1.Server.statusCodes.OK).send({ status: 'OK', result: result });
                        return [3 /*break*/, 5];
                    case 4:
                        error_2 = _a.sent();
                        if (!(error_2 instanceof Error)) {
                            error_2 = new Error(error_2);
                        }
                        status = server_1.Server.statusCodes.INTERNAL_SERVER_ERROR;
                        if (error_2.name === 'UnauthorizedError') {
                            status = server_1.Server.statusCodes.UNAUTHORIZED;
                        }
                        else if (error_2.name === 'BadRequestError') {
                            status = server_1.Server.statusCodes.BAD_REQUEST;
                        }
                        else if (error_2.name === 'ForbiddenError') {
                            status = server_1.Server.statusCodes.FORBIDDEN;
                        }
                        else if (error_2.name === 'NotImplemented') {
                            status = server_1.Server.statusCodes.NOT_IMPLEMENTED;
                        }
                        else if (error_2.name === 'NotFoundError') {
                            status = server_1.Server.statusCodes.NOT_FOUND;
                        }
                        console.error(error_2);
                        response.status(status).send({
                            message: error_2.message
                        });
                        return [3 /*break*/, 5];
                    case 5:
                        core_1.Logger.infoWithElapesedTime("Query handled", startDate);
                        core_1.Logger.info('-'.repeat(30) + "Query API" + '-'.repeat(30));
                        return [2 /*return*/];
                }
            });
        }); };
    };
    HandlerHelper.getFunctionEventHandler = function (bus, db, factory) {
        var _this = this;
        var retryCount = 0;
        var handle = function (snapshot, eventContext) { return __awaiter(_this, void 0, void 0, function () {
            var event, context, startDate, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        event = core_1.deserialize(snapshot.data());
                        context = new context_1.Context(db, factory, { uid: null, displayName: null, email: null, emailVerified: null, photoURL: null }, snapshot);
                        startDate = new Date();
                        if (retryCount === 0) {
                            core_1.Logger.info('-'.repeat(20) + " handling " + event.type + " " + '-'.repeat(20));
                        }
                        else {
                            core_1.Logger.info("Start handling event " + event.type + " (retry " + retryCount + "/5)");
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 9]);
                        return [4 /*yield*/, bus.publish(event, execution_mode_enum_1.ExecutionMode.Asynchronous, context)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.publishEventsOnInternalBus(bus, context)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, context.saveDocumentsAndPublishEvents()];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 5:
                        error_3 = _a.sent();
                        if (!(retryCount < 5)) return [3 /*break*/, 8];
                        retryCount++;
                        console.log("Error received " + (error_3.message ? error_3.message : '') + ", retry " + retryCount + "/5");
                        return [4 /*yield*/, HandlerHelper.wait(1000 * Math.pow(2, retryCount))];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, handle(snapshot, eventContext)];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8:
                        if (error_3 instanceof Error) {
                            console.error(error_3);
                        }
                        else {
                            console.error(new Error(error_3));
                        }
                        return [3 /*break*/, 9];
                    case 9:
                        core_1.Logger.info('-'.repeat(20) + " " + event.type + " handled in " + this.getElapesedTime(startDate) + " " + '-'.repeat(20));
                        core_1.Logger.info('');
                        core_1.Logger.info('');
                        return [2 /*return*/];
                }
            });
        }); };
        return handle;
    };
    HandlerHelper.wait = function (miliseconds) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                console.log("Waiting " + miliseconds + " ms");
                return [2 /*return*/, new Promise(function (resolve) { return setTimeout(function () { return resolve(); }, miliseconds); })];
            });
        });
    };
    HandlerHelper.publishEventsOnInternalBus = function (bus, context) {
        return __awaiter(this, void 0, void 0, function () {
            var publishedEventCount, events, _i, events_1, event;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        publishedEventCount = 0;
                        _a.label = 1;
                    case 1:
                        events = context.getEvents().slice(publishedEventCount);
                        _i = 0, events_1 = events;
                        _a.label = 2;
                    case 2:
                        if (!(_i < events_1.length)) return [3 /*break*/, 5];
                        event = events_1[_i];
                        return [4 /*yield*/, bus.publish(event, execution_mode_enum_1.ExecutionMode.Synchronous, context)];
                    case 3:
                        _a.sent();
                        publishedEventCount++;
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5:
                        if (context.getEvents().length > publishedEventCount) return [3 /*break*/, 1];
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    HandlerHelper.getElapesedTime = function (startDate) {
        var duration = (new Date()).getTime() - startDate.getTime();
        var minutes = Math.floor(duration / 60000);
        var seconds = Math.floor(duration / 1000) - 60000 * minutes;
        var miliseconds = duration - 60000 * minutes - 1000 * seconds;
        if (minutes) {
            return minutes + " min  " + seconds + " sec " + miliseconds + " ms";
        }
        else if (seconds) {
            return seconds + " sec " + miliseconds + " ms";
        }
        return miliseconds + " ms";
    };
    return HandlerHelper;
}());
exports.HandlerHelper = HandlerHelper;
//# sourceMappingURL=handler-helper.js.map