"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationMiddleware = void 0;
var firebase_admin_1 = require("firebase-admin");
var context_1 = require("../context");
var server_1 = require("../server");
function AuthenticationMiddleware(firebaseAdminAuth, database, publicPaths, factory) {
    var _this = this;
    return function (request, response, next) { return __awaiter(_this, void 0, void 0, function () {
        var authorizationHeader, idToken, decodedIdToken, userId, user, error_1, idToken, _a, userId, password, user, error_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    authorizationHeader = request.headers.authorization ? request.headers.authorization.toString() : null;
                    console.log('request.path', request.path);
                    if (!publicPaths.includes(request.path)) return [3 /*break*/, 1];
                    console.log(request.path + " is a public path, no authorization check");
                    request.context = new context_1.Context(database, null);
                    next();
                    return [3 /*break*/, 15];
                case 1:
                    if (!(request.method === 'OPTIONS')) return [3 /*break*/, 2];
                    next();
                    return [3 /*break*/, 15];
                case 2:
                    if (!!authorizationHeader) return [3 /*break*/, 3];
                    response.status(server_1.Server.statusCodes.UNAUTHORIZED).send({ message: 'No authorization header found' });
                    return [3 /*break*/, 15];
                case 3:
                    if (!authorizationHeader.startsWith('Bearer')) return [3 /*break*/, 9];
                    idToken = authorizationHeader.split('Bearer ')[1];
                    _b.label = 4;
                case 4:
                    _b.trys.push([4, 7, , 8]);
                    return [4 /*yield*/, firebaseAdminAuth.verifyIdToken(idToken, true)];
                case 5:
                    decodedIdToken = _b.sent();
                    userId = decodedIdToken.uid;
                    return [4 /*yield*/, firebase_admin_1.auth().getUser(userId)];
                case 6:
                    user = _b.sent();
                    request.context = new context_1.Context(database, factory, user);
                    next();
                    return [3 /*break*/, 8];
                case 7:
                    error_1 = _b.sent();
                    response.status(server_1.Server.statusCodes.UNAUTHORIZED).send({
                        message: "Error while verifying token " + (error_1.message ? error_1.message : null)
                    });
                    return [2 /*return*/];
                case 8: return [3 /*break*/, 15];
                case 9:
                    if (!authorizationHeader.startsWith('Basic')) return [3 /*break*/, 14];
                    idToken = authorizationHeader.split('Basic ')[1];
                    _b.label = 10;
                case 10:
                    _b.trys.push([10, 12, , 13]);
                    _a = Buffer.from(idToken, 'base64').toString().split(':'), userId = _a[0], password = _a[1];
                    return [4 /*yield*/, firebase_admin_1.auth().getUser(userId)];
                case 11:
                    user = _b.sent();
                    if (password !== '20V0anV4M!we') {
                        throw new Error('Wrong password!!');
                    }
                    request.context = new context_1.Context(database, factory, user);
                    next();
                    return [3 /*break*/, 13];
                case 12:
                    error_2 = _b.sent();
                    response.status(server_1.Server.statusCodes.UNAUTHORIZED).send({
                        message: "Error while verifying token " + (error_2.message ? error_2.message : null)
                    });
                    return [2 /*return*/];
                case 13: return [3 /*break*/, 15];
                case 14:
                    response.status(server_1.Server.statusCodes.UNAUTHORIZED).send({ message: 'Incorrect authorization header' });
                    _b.label = 15;
                case 15: return [2 /*return*/];
            }
        });
    }); };
}
exports.AuthenticationMiddleware = AuthenticationMiddleware;
//# sourceMappingURL=authentication-middleware.js.map