"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeadersMiddleWare = void 0;
function HeadersMiddleWare() {
    return function (_req, res, next) {
        res.removeHeader('X-Powered-By'); // Remove verbose express
        res.setHeader('Cache-Control', 'no-cache, no-store, must-revalidate'); // HTTP 1.1.
        res.setHeader('Pragma', 'no-cache'); // HTTP 1.0.
        res.setHeader('Expires', '0'); // Proxies.
        res.setHeader('Content-Type', 'application/json'); // default response type
        res.setHeader('Access-Control-Allow-Credentials', 'true');
        next();
    };
}
exports.HeadersMiddleWare = HeadersMiddleWare;
//# sourceMappingURL=headers-middleware.js.map