import { Event } from '@we-scrum/core';
import { Bus } from './bus';
import { Context } from './context';
import { ExecutionMode } from './execution-mode-enum';
export declare class Projection {
    protected bus: Bus;
    private handlers;
    constructor(bus: Bus);
    handle(event: Event, mode: ExecutionMode, context: Context): Promise<void>;
    isRegisteredEvent(type: string, mode: ExecutionMode): boolean;
    protected on<T extends Event>(eventType: new () => T, handler: Projection.EventHandler<T>, mode: ExecutionMode): void;
    private getDictionaryKey;
}
export declare namespace Projection {
    interface EventHandler<T extends Event> {
        (event: T, context: Context): Promise<void>;
    }
}
