import { EnumHelper, Event } from '@we-scrum/core';
import { Context } from './context';
export declare class Repository {
    private context;
    constructor(context: Context);
    protected getEvents(): Event[];
    protected _get<T>(path: string): Promise<T>;
    protected _getAll<T>(collection: string): Promise<T[]>;
    protected _getWhere<T>(collection: string, whereClauses?: [string, Repository.Operator, any | any[]][], orderBy?: string): Promise<T[]>;
    private getCollectionReference;
}
export declare namespace Repository {
    enum Operator {
        EqualTo = "==",
        LessThan = "<",
        GreaterThan = ">",
        AtMost = "<=",
        AtLeast = ">=",
        In = "in",
        ArrayContains = "array-contains",
        ArrayContainsAny = "array-contains-any"
    }
    namespace Operator {
        class OperatorEnumHelper extends EnumHelper<Operator> {
            getOperatorString(operator: Repository.Operator): '==' | '<' | '>' | '<=' | '>=' | 'in' | 'array-contains' | 'array-contains-any';
        }
        export const helper: OperatorEnumHelper;
        export {};
    }
}
