"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Repository = void 0;
var core_1 = require("@we-scrum/core");
var context_1 = require("./context");
var Repository = /** @class */ (function () {
    function Repository(context) {
        this.context = context;
    }
    Repository.prototype.getEvents = function () {
        return this.context.getEvents();
    };
    Repository.prototype._get = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var doc, result, resultInTransaction;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        core_1.Logger.info('Repository: get', path);
                        return [4 /*yield*/, this.context.db.doc(path).get()];
                    case 1:
                        doc = _a.sent();
                        result = doc.data();
                        if (!result) {
                            resultInTransaction = this.context.getOperations().find(function (o) { return o.action === context_1.Context.Action.Create && o.document._path === path; });
                            if (resultInTransaction) {
                                return [2 /*return*/, resultInTransaction.document];
                            }
                            throw new core_1.NotFoundError("Repository: document " + path + " not found");
                        }
                        return [2 /*return*/, core_1.deserialize(result)];
                }
            });
        });
    };
    Repository.prototype._getAll = function (collection) {
        return __awaiter(this, void 0, void 0, function () {
            var documents, querySnapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        core_1.Logger.info('Repository: getAll', collection);
                        documents = [];
                        return [4 /*yield*/, this.getCollectionReference(collection).get()];
                    case 1:
                        querySnapshot = _a.sent();
                        querySnapshot.forEach(function (doc) {
                            documents.push(core_1.deserialize(doc.data()));
                        });
                        return [2 /*return*/, documents];
                }
            });
        });
    };
    Repository.prototype._getWhere = function (collection, whereClauses, orderBy) {
        if (whereClauses === void 0) { whereClauses = []; }
        if (orderBy === void 0) { orderBy = null; }
        return __awaiter(this, void 0, void 0, function () {
            var documents, query, querySnapshot;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        core_1.Logger.info('Repository: getWhere', collection, whereClauses);
                        documents = [];
                        query = this.getCollectionReference(collection);
                        whereClauses.forEach(function (where) {
                            query = query.where(where[0], Repository.Operator.helper.getOperatorString(where[1]), where[2]);
                        });
                        if (orderBy) {
                            query = query.orderBy(orderBy);
                        }
                        return [4 /*yield*/, query.get()];
                    case 1:
                        querySnapshot = _a.sent();
                        querySnapshot.forEach(function (doc) {
                            documents.push(core_1.deserialize(doc.data()));
                        });
                        return [2 /*return*/, documents];
                }
            });
        });
    };
    Repository.prototype.getCollectionReference = function (collection) {
        if (collection.startsWith('**/')) {
            return this.context.db.collectionGroup(collection.replace('**/', ''));
        }
        else {
            return this.context.db.collection(collection);
        }
    };
    return Repository;
}());
exports.Repository = Repository;
(function (Repository) {
    var Operator;
    (function (Operator) {
        Operator["EqualTo"] = "==";
        Operator["LessThan"] = "<";
        Operator["GreaterThan"] = ">";
        Operator["AtMost"] = "<=";
        Operator["AtLeast"] = ">=";
        Operator["In"] = "in";
        Operator["ArrayContains"] = "array-contains";
        Operator["ArrayContainsAny"] = "array-contains-any";
    })(Operator = Repository.Operator || (Repository.Operator = {}));
    (function (Operator) {
        var OperatorEnumHelper = /** @class */ (function (_super) {
            __extends(OperatorEnumHelper, _super);
            function OperatorEnumHelper() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            OperatorEnumHelper.prototype.getOperatorString = function (operator) {
                switch (operator) {
                    case Repository.Operator.EqualTo:
                        return '==';
                    case Repository.Operator.LessThan:
                        return '<';
                    case Repository.Operator.GreaterThan:
                        return '>';
                    case Repository.Operator.AtMost:
                        return '<=';
                    case Repository.Operator.AtLeast:
                        return '>=';
                    case Repository.Operator.In:
                        return 'in';
                    case Repository.Operator.ArrayContains:
                        return 'array-contains';
                    case Repository.Operator.ArrayContainsAny:
                        return 'array-contains-any';
                    default:
                        throw new Error("Operator " + operator);
                }
            };
            return OperatorEnumHelper;
        }(core_1.EnumHelper));
        Operator.helper = new OperatorEnumHelper('Operator', [
            Operator.EqualTo,
            Operator.LessThan,
            Operator.GreaterThan,
            Operator.AtMost,
            Operator.AtLeast,
            Operator.In,
            Operator.ArrayContains,
            Operator.ArrayContainsAny
        ]);
    })(Operator = Repository.Operator || (Repository.Operator = {}));
})(Repository = exports.Repository || (exports.Repository = {}));
exports.Repository = Repository;
//# sourceMappingURL=repository.js.map