"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Server = void 0;
var cors = require("cors");
var express = require("express");
var httpStatusCodes = require("http-status-codes");
var middlewares = require("./middlewares");
var Server = /** @class */ (function () {
    function Server(options) {
        this._app = express();
        this.registerMiddleWare(cors({ origin: true }));
        this.registerMiddleWare(middlewares.HeadersMiddleWare());
        this.registerMiddleWare(middlewares.AuthenticationMiddleware(options.firebaseAuth, options.firestore, options.publicPaths, options.factory));
    }
    Server.prototype.registerMiddleWare = function (middleware) {
        this._app.use(middleware);
    };
    Server.prototype.registerErrorHlandler = function (middleware) {
        this._app.use(middleware);
    };
    Server.prototype.registerRouter = function (path, router) {
        this._app.use(path, router);
    };
    Server.prototype.getNewRouter = function () {
        return express.Router();
    };
    Object.defineProperty(Server.prototype, "app", {
        get: function () {
            this.registerMiddleWare(middlewares.NotFoundMiddleware());
            return this._app;
        },
        enumerable: false,
        configurable: true
    });
    Server.statusCodes = httpStatusCodes;
    return Server;
}());
exports.Server = Server;
//# sourceMappingURL=server.js.map